/*
    GT Window: WGL Edition
    Copyright (C) 2006 G-Truc Creation (www.g-truc.net)

    Christophe [Groove] Riccio
    contact@g-truc.net
*/

namespace gtw
{
	template <typename T> 
	T* singleton<T>::m_pInstance = 0;

	template <typename T> 
	T* singleton<T>::instance()
	{
		if(m_pInstance == 0)
			m_pInstance = new T;
		return m_pInstance;
	}

	template <typename T> 
	void singleton<T>::destroy()
	{
		if(m_pInstance != 0)
		{
			delete m_pInstance;
			m_pInstance = 0;
		}
	}

	template <typename T> 
	bool singleton<T>::isCreated()
	{
		return m_pInstance != 0;
	}
}
